﻿#Copyright 9/25/2016
#This code is released into the public domain

#Mark Johnson <mrk.jhsn@gmail.com>
#JT Moree <moreejt@yahoo.com>

#to do:
#clean up status output option to combine objects, cleaner for use later


#accepting the below parameters to be used

param(

    [Parameter(Mandatory=$true)]$site #the name or IP of the Open Garage device.  Include Protocol (HTTP) 
    ,[Parameter(Mandatory=$true)]$dkey=$null  #the device key defined in the Open Garage device.  Default opendoor.
    ,$action = "status" #status, opendoor, closedoor #the action to take
 
 )

 $DebugPreference = "Continue"
 write-debug "The action is $action"

$getstatus="/jc"
$changestatus="/cc"

if ($action -eq "status") {
    "these are the options in Open Garage"

    $current = Invoke-WebRequest -Uri $site$getstatus
    $status = $current.Content |ConvertFrom-Json
  
    $current = Invoke-WebRequest -Uri $site/jo
    $status2 = ($current.Content |ConvertFrom-Json),$status
    
        write-output $status2
        
} elseif ($action -eq "opendoor") {

    $current = Invoke-WebRequest -Uri $site$getstatus
    $status = $current.Content |ConvertFrom-Json
    if ($status.door -eq "0") {
      "Door is closed"
      $closedoor = Invoke-WebRequest -Uri "${site}${changestatus}?dkey=$dkey&click=0"

    } else {

      "Door is open"
    }
    
} elseif ($action -eq "closedoor") {

    $current = Invoke-WebRequest -Uri $site$getstatus
    $status = $current.Content |ConvertFrom-Json
    if ($status.door -eq "1") {
      "Door is open"
      $closedoor = Invoke-WebRequest -Uri "${site}${changestatus}?dkey=$dkey&click=1"

    } else {

      "Door is closed"
    }
} else {
    throw "Invalid Action: '$action'"
}

